#include "Energia.h"

#line 1 "C:/Users/a0219221/workspace_v10/GetDistance/GetDistance.ino"










#include <PGA460_USSC.h>
















#define userInputMode         











  void setup();
void initPGA460();
void loop();
void serialEvent();

#line 40
byte commMode = 0;            
  byte fixedThr = 1;            
  byte xdcr = 0;                
  byte agrTVG = 2;              
  byte fixedTVG = 1;            
  byte runDiag = 0;             
  byte edd = 0;                 
  byte burn = 0;                
  byte cdMultiplier = 1;        
  byte numOfObj = 2;            
  byte uartAddrUpdate = 0;      
  bool objectDetected = false;  
  bool demoMode = false;        
  bool alwaysLong = false;      
  double minDistLim = 0.1;      
  uint16_t commandDelay = 0;    
  uint32_t baudRate = 9600;     
  int ioTogPin = 15;            


  const int buttonPin = PUSH2;  
  int buttonState = 0;          


  double distance = 0;          
  double width = 0;             
  double peak = 0;              
  double diagnostics = 0;       
  byte echoDataDumpElement = 0; 
  String interruptString = "";  
  boolean stringComplete = false; 


  pga460 ussc;






void setup() {                
  
  initPGA460(); 
  }























void initPGA460() {
  
    #ifdef userInputMode
    int inByte = 0;         
    
    Serial.begin(baudRate); 
    delay(1000);

    commMode = 0;       
    baudRate=9600;      
    fixedThr= 0;        
    xdcr= 0;            
    agrTVG=1;           
    fixedTVG =0;        
    minDistLim =0.3;      
    runDiag = 1;        
    edd = 1;             
    burn = 0;            
    cdMultiplier = 2 ;      
    numOfObj = 1 ;      
    uartAddrUpdate = 0; 
     
    Serial.println("Configuring the PGA460 with the selected settings. Wait...");
    delay(300);

  #else  
    pinMode(buttonPin, INPUT_PULLUP);         
    while (digitalRead(buttonPin) == HIGH){}  
  #endif













  
    ussc.initBoostXLPGA460(commMode, baudRate, uartAddrUpdate); 
    
  
    if (fixedThr != 72){ussc.initThresholds(fixedThr);} 
  
    if (xdcr != 72){ussc.defaultPGA460(xdcr);}
  
    if (agrTVG != 72 && fixedTVG != 72){ussc.initTVG(agrTVG,fixedTVG);}
  
    if (runDiag == 1)
    {      
      diagnostics = ussc.runDiagnostics(1,0);       
      Serial.print("System Diagnostics - Frequency (kHz): "); Serial.println(diagnostics);
      diagnostics = ussc.runDiagnostics(0,1);       
      Serial.print("System Diagnostics - Decay Period (us): "); Serial.println(diagnostics);
      diagnostics = ussc.runDiagnostics(0,2);       
      Serial.print("System Diagnostics - Die Temperature (C): "); Serial.println(diagnostics);
      diagnostics = ussc.runDiagnostics(0,3);       
      Serial.print("System Diagnostics - Noise Level: "); Serial.println(diagnostics);
    }
  
    if(burn == 1)
    {
      byte burnStat = ussc.burnEEPROM();
      if(burnStat == true){Serial.println("EEPROM programmed successfully.");}
      else{Serial.println("EEPROM program failed.");}
    }
  
    if (edd != 0)                                   
    {
      Serial.println("Retrieving echo data dump profile. Wait...");
      ussc.runEchoDataDump(edd-1);                  
      Serial.print(ussc.pullEchoDataDumpBulk());
      Serial.println("");
    }
  
  commandDelay = 100 * cdMultiplier;                   
  if (numOfObj == 0 || numOfObj >8) { numOfObj = 1; } 

  byte register_value;
  for (int register_number=0x14; register_number<0x2c; register_number++)
      {
        register_value=ussc.registerRead( register_number);
       
        
        
        Serial.println(register_value, HEX);
      }
      for (int register_number=0x40; register_number<0x4E; register_number++)
      {
        register_value=ussc.registerRead( register_number);
        
        
        
        Serial.println(register_value, HEX);
      }
      for (int register_number=0x5F; register_number<0x80; register_number++)
      {
        register_value=ussc.registerRead( register_number);
        
        
        
        Serial.println(register_value, HEX);
      }




}



























void loop() {                 
    
      objectDetected = false;                       
      ussc.ultrasonicCmd(0,numOfObj);               
      ussc.pullUltrasonicMeasResult(demoMode);      
      for (byte i=0; i<numOfObj; i++)
      {      
        
          distance = ussc.printUltrasonicMeasResult(0+(i*3));      
          
          
  
        delay(commandDelay);
    
        if (distance > minDistLim && distance < 11.2)  
        {
            ussc.toggleLEDs(HIGH,LOW,LOW);
            Serial.print("P1 Obj"); Serial.print(i+1); Serial.print(" Distance (m): "); Serial.println(distance);
            
            
            objectDetected = true;
        }
      }
    
    
      if(objectDetected == false || alwaysLong == true)                       
      {   
        ussc.ultrasonicCmd(1,numOfObj);                
        ussc.pullUltrasonicMeasResult(demoMode);                
        for (byte i=0; i<numOfObj; i++)
        {  
          distance = ussc.printUltrasonicMeasResult(0+(i*3));   
          
          
  
          delay(commandDelay);
    
          if (distance < 1 && distance > minDistLim)    
          {
              ussc.toggleLEDs(HIGH,LOW,LOW);
              Serial.print("P2 Obj"); Serial.print(i+1); Serial.print(" Distance (m): "); Serial.println(distance);
              
              
              objectDetected = true;
          } 
          else if (distance < 3 && distance >= 1)      
          {
              ussc.toggleLEDs(HIGH,HIGH,LOW);
              Serial.print("P2 Obj"); Serial.print(i+1); Serial.print(" Distance (m): "); Serial.println(distance);
              objectDetected = true;
          }    
          else if (distance >= 3 && distance < 11.2)     
          {
              ussc.toggleLEDs(HIGH,HIGH,HIGH);
              Serial.print("P2 Obj"); Serial.print(i+1); Serial.print(" Distance (m): "); Serial.println(distance);
              objectDetected = true;
          }    
          else if (distance == 0 && commMode!=1)                         
          {
              ussc.toggleLEDs(LOW,LOW,LOW);
              
          }
          else 
          {
              if (i == numOfObj-1 && objectDetected == false)
              {
                ussc.toggleLEDs(LOW,LOW,LOW);            
                Serial.println("No object...");
              }
          }
        }  
      }
    
    
      digitalWrite(GREEN_LED, !digitalRead(GREEN_LED));   
      digitalWrite(RED_LED, !digitalRead(RED_LED));     
}







void serialEvent() {
    while (Serial.available()) {
      char inChar = (char)Serial.read(); 
      
      
      if (inChar == 'q'){stringComplete = true; initPGA460();}
      
      
      else if (inChar == 'p')
      {
        Serial.println("PAUSE");
        stringComplete = false; 
        while(stringComplete == false)
        {
          while (Serial.available())
          {
            inChar = (char)Serial.read(); 
            if (inChar == 'p')
              {
                stringComplete = true;
              }
            if (inChar == 'q')
            {
              stringComplete = true; 
              initPGA460();
            }
            delay(1000);
          }
        }
        stringComplete=false;
        Serial.println("");
      }    
       
      else {} 
  }
}





